﻿<Serializable()> _
Public Class clsDrawingObjectConnection

    Inherits clsDrawingObject

    Private RealStart As Point = Point.Empty ' New Point(StartPunkt.X + Abstand, StartPunkt.Y)
    Private RealEnde As Point = Point.Empty ' New Point(EndPunkt.X - Abstand, EndPunkt.Y)
    Private RealMitte As Point = Point.Empty
    Private RealMitteBezier1 As Point = Point.Empty
    Private RealMitteBezier2 As Point = Point.Empty

    'Public Sub New(Owner As clsDrawingPanel)
    '    MyBase.New(Owner)
    'End Sub

    'Public Sub New(Owner As clsDrawingPanel, StartP As Point, EndP As Point)
    '    MyBase.New(Owner)
    '    Me.StartPunkt = StartP
    '    Me.EndPunkt = EndP
    'End Sub

    'Public Sub New(Owner As clsDrawingPanel, StartP_X As Integer, StartP_Y As Integer, EndP_X As Integer, EndP_Y As Integer)
    '    MyBase.New(Owner)
    '    Me.StartPunkt = New Point(StartP_X, StartP_Y)
    '    Me.EndPunkt = New Point(EndP_X, EndP_Y)
    'End Sub

    'Public Sub New(Owner As clsDrawingPanel, StartP As Point, EndP As Point, StiftN As Pen)
    '    MyBase.New(Owner)
    '    Me.StartPunkt = StartP
    '    Me.EndPunkt = EndP
    '    Me.Stift = StiftN
    'End Sub

    'Public Sub New(Owner As clsDrawingPanel, StartP_X As Integer, StartP_Y As Integer, EndP_X As Integer, EndP_Y As Integer, StiftN As Pen)
    '    MyBase.New(Owner)
    '    Me.StartPunkt = New Point(StartP_X, StartP_Y)
    '    Me.EndPunkt = New Point(EndP_X, EndP_Y)
    '    Me.Stift = StiftN
    'End Sub

    Public Sub New(Owner As clsDrawingPanel, ConnectPartnerStart As clsDrawingObject, ConnectPartnerEnd As clsDrawingObject)
        MyBase.New(Owner)
        Me.ConnectionPartnerStart = ConnectPartnerStart
        Me.ConnectionPartnerEnde = ConnectPartnerEnd
    End Sub

    Private m_Abstand As Integer = 20
    Public Property Abstand() As Integer
        Get
            'CalcDimensions()
            Return m_Abstand
        End Get
        Set(ByVal value As Integer)
            m_Abstand = value
            CalcDimensions()
        End Set
    End Property

    Private m_StartPunkt As Point
    Public Property StartPunkt() As Point
        Get
            CalcDimensions()
            Return m_StartPunkt
        End Get
        Set(ByVal value As Point)
            m_StartPunkt = value
            CalcDimensions()
        End Set
    End Property

    Private m_EndPunkt As Point
    Public Property EndPunkt() As Point
        Get
            'CalcDimensions()
            Return m_EndPunkt
        End Get
        Set(ByVal value As Point)
            m_EndPunkt = value
            CalcDimensions()
        End Set
    End Property

    Private m_Stift As Pen = New Pen(Brushes.Black, 1)
    Public Property Stift() As Pen
        Get
            Return m_Stift
        End Get
        Set(ByVal value As Pen)
            m_Stift = value
        End Set
    End Property

    Private m_ConnectionPartnerStart As clsDrawingObject
    Public Property ConnectionPartnerStart() As clsDrawingObject
        Get
            Return m_ConnectionPartnerStart
        End Get
        Set(ByVal value As clsDrawingObject)
            m_ConnectionPartnerStart = value
            CalcDimensions()
        End Set
    End Property

    Private m_ConnectionPartnerEnde As clsDrawingObject
    Public Property ConnectionPartnerEnde() As clsDrawingObject
        Get
            Return m_ConnectionPartnerEnde
        End Get
        Set(ByVal value As clsDrawingObject)
            m_ConnectionPartnerEnde = value
            CalcDimensions()
        End Set
    End Property

    Private Sub CalcDimensions()
        If ConnectionPartnerEnde Is Nothing Then Exit Sub
        If ConnectionPartnerStart Is Nothing Then Exit Sub

        m_StartPunkt = ConnectionPartnerStart.Mittelpunkt(ConnectionPartnerStart.Location)
        m_EndPunkt = ConnectionPartnerEnde.Mittelpunkt(ConnectionPartnerEnde.Location)

        If Math.Abs(m_EndPunkt.X - m_StartPunkt.X) < m_Abstand Then
            m_Abstand = Math.Abs(m_EndPunkt.X - m_StartPunkt.X)
        End If

        RealStart = New Point(m_StartPunkt.X + m_Abstand, m_StartPunkt.Y)
        RealEnde = New Point(m_EndPunkt.X - m_Abstand, m_EndPunkt.Y)
        RealMitte = New Point(CInt(m_StartPunkt.X + (m_EndPunkt.X - m_StartPunkt.X) / 2), CInt(m_StartPunkt.Y + (m_EndPunkt.Y - m_StartPunkt.Y) / 2))
        RealMitteBezier1 = New Point(CInt(m_StartPunkt.X + (m_EndPunkt.X - m_StartPunkt.X) / 4), CInt(m_StartPunkt.Y + (m_EndPunkt.Y - m_StartPunkt.Y) / 2))
        RealMitteBezier2 = New Point(CInt(m_StartPunkt.X + ((m_EndPunkt.X - m_StartPunkt.X) / 4) * 3), CInt(m_StartPunkt.Y + (m_EndPunkt.Y - m_StartPunkt.Y) / 2))
    End Sub

    Friend Overrides Sub Paint(g As System.Drawing.Graphics)
        If g Is Nothing Then Exit Sub
        If Stift Is Nothing Then Exit Sub
        If Me.isSelected Then
            Stift.Color = Color.Blue
        ElseIf Me.isHovered Then
            Stift.Color = Color.Red
        ElseIf Me.isHighlighted Then
            Stift.Color = Color.Blue
        End If
        g.DrawBezier(Stift, StartPunkt.X, StartPunkt.Y, RealStart.X, RealStart.Y, RealMitteBezier1.X, RealStart.Y, RealMitte.X, RealMitte.Y)
        g.DrawBezier(Stift, RealMitte.X, RealMitte.Y, RealMitteBezier2.X, RealEnde.Y, RealEnde.X, RealEnde.Y, EndPunkt.X, EndPunkt.Y)
    End Sub

End Class
